VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsShutdown"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const TOKEN_ADJUST_PRIVILEGES As Long = &H20
Private Const SE_SHUTDOWN_NAME As String = "SeShutdownPrivilege"
Private Const SE_PRIVILEGE_ENABLED As Long = &H2

Private Const EWX_LOGOFF As Long = 0&
Private Const EWX_SHUTDOWN As Long = 1&
Private Const EWX_REBOOT As Long = 2&
Private Const EWX_FORCE As Long = 4&
Private Const EWX_POWEROFF As Long = 8&
Private Const EWX_FORCEIFHUNG As Long = 16&

Private Type LUID
    lowpart As Long
    highpart As Long
End Type

Private Type LUID_AND_ATTRIBUTES
    pLuid As LUID
    Attributes As Long
End Type

Private Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges As LUID_AND_ATTRIBUTES
End Type

Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" ( _
     ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, _
     NewState As TOKEN_PRIVILEGES, BufferLength As Any, _
     PreviousState As Any, ReturnLength As Any) As Long

Private Declare Function ExitWindowsEx Lib "user32.dll" ( _
     ByVal uFlags As Long, ByVal dwReserved As Long) As Long

Private Declare Function OpenProcessToken Lib "advapi32.dll" ( _
     ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, _
     TokenHandle As Long) As Long
     
Private Declare Function GetCurrentProcess Lib "kernel32.dll" () As Long

Private Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" ( _
     ByVal lpSystemName As String, ByVal lpName As String, _
     lpLuid As LUID) As Long

Public Function ShutDownDOSbasedWindows(ByVal ShutDownMode As Long) As Boolean
    Dim retval As Long
    retval = ExitWindowsEx(ShutDownMode, 0&)
    
    If retval = 0 Then
        MsgBox "Error! "
                    
        Exit Function
    End If
    
    ShutDownDOSbasedWindows = True
End Function

Public Function ShutDownNTbasedWindows(ByVal ShutDownMode As Long) As Boolean
    Dim retval As Long
    
    If (ShutDownMode And EWX_SHUTDOWN) > 0 Or _
       (ShutDownMode And EWX_POWEROFF) > 0 Or _
       (ShutDownMode And EWX_REBOOT) > 0 Then
       
            If Not AdjustPrivilege2ShutdownOrRestart(True) Then
                MsgBox "Adjusting Privilege failed!"
                Exit Function
                Else
                'MsgBox "Succesful!"
            End If
    End If
    
    ShutDownNTbasedWindows = ShutDownDOSbasedWindows(ShutDownMode)
    
    If (ShutDownMode And EWX_SHUTDOWN) > 0 Or _
       (ShutDownMode And EWX_POWEROFF) > 0 Or _
       (ShutDownMode And EWX_REBOOT) > 0 Then
       
            If Not AdjustPrivilege2ShutdownOrRestart(False) Then
                ' Meckere nicht, denn fr den Anwender spielt es im Prinzip keine Rolle
            End If
    End If
End Function

Private Function AdjustPrivilege2ShutdownOrRestart(ByVal EnablePrivilege As Boolean) As Boolean
    Dim retval As Long, hToken As Long
    
    'Zunchst ein Handle fr den Accesstoken des aktuellen Prozesses ermitteln
    retval = OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, hToken)
    If retval = 0 Then
        MsgBox "Error! "
                    
        Exit Function
    End If
    
    ' Nun den aktuellen LUID fr das SE_SHUTDOWN-Privileg ermitteln
    Dim SE_SHUTDOWN_LI As LUID
    
    retval = LookupPrivilegeValue(vbNullString, SE_SHUTDOWN_NAME, SE_SHUTDOWN_LI)
    If retval = 0 Then
        MsgBox "Error! "
                     
        Exit Function
    End If
     
    'Das SE_SHUTDOWN-Privileg aktivieren
    Dim tokenpriv As TOKEN_PRIVILEGES
    
    'durch den angepassten UDT immer 1
    tokenpriv.PrivilegeCount = 1
    If EnablePrivilege Then
        'Privileg aktivieren
        tokenpriv.Privileges.Attributes = SE_PRIVILEGE_ENABLED
    Else
        'Privileg deaktivieren
        tokenpriv.Privileges.Attributes = 0
    End If
    
    'LUID zuweisen
    tokenpriv.Privileges.pLuid.highpart = SE_SHUTDOWN_LI.highpart
    tokenpriv.Privileges.pLuid.lowpart = SE_SHUTDOWN_LI.lowpart
    
    'Anpassung durchfhren
    retval = AdjustTokenPrivileges(hToken, 0, tokenpriv, _
                ByVal CLng(0), ByVal CLng(0), ByVal CLng(0))
                
    If retval = 0 Then
        MsgBox "Error! "
                     
        Exit Function
    End If
    
    AdjustPrivilege2ShutdownOrRestart = True
End Function

